package fr.username404.snowygui.config

import com.typesafe.config.Config
import com.typesafe.config.ConfigException
import com.typesafe.config.ConfigFactory
import fr.username404.snowygui.Snowy
import net.minecraft.client.Minecraft
import java.io.File

object Configuration {
    private val file: File = File(Minecraft.getInstance().gameDirectory.absolutePath + File.separator + "snowy.conf")
    private val base = """
        |Snowy {
        |  displayInitMessage = true
        |}
    """.trimMargin()
    val obtained: Config = run {
        var result: Config? = null
        with(file) {
            if (!exists()) {
                createNewFile()
                setWritable(true)
                writeText(base)
                setReadable(true)
            } else result = try {
                ConfigFactory.parseFile(file)
            } catch (e: ConfigException) {
                Snowy.logs.warn("Could not parse the snowy configuration file, the default configuration will be used instead."); null
            }
        }
        if (result == null) result = ConfigFactory.parseString(base)
        ConfigFactory.load(result).getConfig("Snowy")
    }
}
